C ********************************************************************
C * EDiT - Electronic Dipole-induced Transitions                     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  INCLUDEFILE DCONSTS                                             *
C *                                                                  *
C *  Routine of EDiT/CEDiT                                           *
C *  version for IBM-PC MS-DOS, Microsoft FORTRAN and                *
C *              IBM-RISC UNIX, AIX XL FORTRAN                       * 
C *                                                                  *
C *  Usage......: Contains the constants used to calculate the       *
C *               <d|O|s>, <d|O|p> and the <d|O|d> offdiagonal       *
C *               elements.                                          *
C *                                                                  *
C *  Authors....: Ruedi Rytz                                         *
C *                                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: August 1992                                        *
C *  Revision...: -                                                  *
C *                                                                  *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Incluede in: DOSELE                                             *
C *               DOPELE                                             *
C *               DODELE                                             *
C *                                                                  *
C ********************************************************************

      DOUBLE PRECISION  SQRT3, SQ1D5, SQ7D10, SQRT2, SQ3D5, SQ7D30
      DOUBLE PRECISION  SQ9D10, SQ3D10, SQ4D5, SQ1D2
      PARAMETER (SQRT3 = 1.732051D0,  SQ1D5 = 4.472136D-1)
      PARAMETER (SQ7D10= 8.366600D-1, SQRT2 = 1.414214D0 )
      PARAMETER (SQ3D5 = 7.745967D-1, SQ7D30= 4.830459D-1)
      PARAMETER (SQ9D10= 9.486833D-1, SQ3D10= 5.477263D-1)
      PARAMETER (SQ4D5 = 8.944272D-1, SQ1D2 = 7.071068D-1) 
