C ********************************************************************
C * EDiT - Electronic Dipole-induced Transitions                     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE FPOVL                                                *
C *                                                                  *
C *  Routine of EDiT/CEDiT                                           *
C *  version for IBM-PC MS-DOS, Microsoft FORTRAN and                *
C *              IBM-RISC UNIX, AIX XL FORTRAN                       * 
C *                                                                  *
C *  Usage......: Projects the f-p-overlap to the axes. The matrix   *
C *               looks as follows:                                  *
C *                                                                  *
C * <Px|X3> <Px|XZ2> <Px|YZ2> <Px|XYZ> <Px|Z(X2-Y2)> <Px|X3> <Px|Y3> *
C * <Py|X3> <Py|XZ2> <Py|YZ2> <Py|XYZ> <Py|Z(X2-Y2)> <Py|X3> <Py|Y3> *
C * <Pz|X3> <Pz|XZ2> <Pz|YZ2> <Pz|XYZ> <Pz|Z(X2-Y2)> <Pz|X3> <Pz|Y3> *
C *                                                                  *
C *  Authors....: Ruedi Rytz                                         *
C *                                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: -                                                  *
C *  Revision...: -                                                  *
C *                                                                  *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: LOVLAP                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE FPOVL(FPOOVL, SIGMA, PI, PTR, FTR)

      IMPLICIT NONE

        DOUBLE PRECISION FPOOVL(3,7), SIGMA, PI, PTR(9), FTR(49)

C VAR
      INTEGER I, J

C BEGIN
      DO 10 J = 1,3
        DO 20 I = 1,7
          FPOOVL(J,I) = PTR(J) * FTR(I) * SIGMA + (PTR(J+3) * FTR(I+7)
     .                  + PTR(J+6) * FTR(I+14)) * PI 
20      CONTINUE
10    CONTINUE

      RETURN
      END
C END
