C ********************************************************************
C * EDiT - Electronic Dipole-induced Transitions                     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE MOUT                                                 *
C *                                                                  *
C *  Routine of EDiT/CEDiT                                           *
C *  version for IBM-PC MS-DOS, Microsoft FORTRAN and                *
C *              IBM-RISC UNIX, AIX XL FORTRAN                       *
C *                                                                  *
C *  Usage......: Prints out the transition matrix.                  *
C *                                                                  *
C *  Authors....: Ruedi Rytz                                         *
C *                                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: June 1992                                          *
C *  Revision...: -                                                  *
C *                                                                  *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: MATRIX                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************

      SUBROUTINE MOUT (M,ANZAO,SIZE)

      IMPLICIT NONE

      INCLUDE 'sizes'

        DOUBLE PRECISION M(MAXAO,MAXAO)
        INTEGER          ANZAO, SIZE

C VAR
      COMMON /IOUNIT/IIN,IOUT,ISTART(40)
      INTEGER IIN, IOUT, ISTART
 
      INTEGER I, J, K, STARTI, ENDEI, STARTJ, ENDEJ

C BEGIN
      ENDEI  = 0
C     REPEAT
2     CONTINUE

        STARTI = ENDEI + 1
        IF (ENDEI + SIZE .GE. ANZAO) THEN
          ENDEI = ANZAO
        ELSE
          ENDEI = ENDEI + SIZE
        ENDIF

        ENDEJ  = 0

C       REPEAT
5       CONTINUE
          STARTJ = ENDEJ + 1
          IF (ENDEJ + SIZE .GE. ANZAO) THEN
            ENDEJ = ANZAO
          ELSE
            ENDEJ = ENDEJ + SIZE
          ENDIF

          WRITE (IOUT, '(A3,$)' ) '   '
          DO 10 K = STARTJ, ENDEJ
            WRITE (IOUT, ' (5X,I3,$) ' ) K
10        CONTINUE
          WRITE (IOUT, ' (/) ' )

          DO 20 I = STARTI, ENDEI
            WRITE (IOUT, ' (I3,$) ' ) I
            WRITE (IOUT, ' (50(1X,F7.4)) ' ) (M(I,J), J = STARTJ, ENDEJ)
20        CONTINUE
          WRITE (IOUT, ' (/) ' )

        IF (ENDEJ .LT. ANZAO) GOTO 5
C       UNTIL ENDEJ < ANZAO

      IF (ENDEI .LT. ANZAO) GOTO 2
C     UNTIL ENDEI < ANZAO

      RETURN
      END
C END
