C ********************************************************************
C * EDiT - Electronic Dipole-induced Transitions                     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  INCLUDEFILE PFNS                                                *
C *                                                                  *
C *  Routine of EDiT/CEDiT                                           *
C *  version for IBM-PC MS-DOS, Microsoft FORTRAN and                *
C *              IBM-RISC UNIX, AIX XL FORTRAN                       * 
C *                                                                  *
C *  Usage......: Functions used to calculate <p|O|s>, <p|O|p>       *
C *               and <p|O|d> offdiagonal elements.                  *
C *                                                                  *
C *  Authors....: Ruedi Rytz                                         *
C *                                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: September 1992                                     *
C *  Revision...: -                                                  *
C *                                                                  *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Included in: POSELE                                             *
C *               POPELE                                             *
C *               PODELE                                             *
C *                                                                  *
C ********************************************************************

      DOUBLE PRECISION I2XX, I3XX, I4XX, XY
      DOUBLE PRECISION D1, D2, S, P

      I2XX(D1, D2, S, P) =
     .     NORM1 * (SQRT3 * D1 - D2 + SQRT5 * S) + LDIST * P

      I3XX(D1, D2, S, P) =
     .     NORM1 * (-SQRT3 * D1 - D2 + SQRT5 * S) + LDIST * P

      I4XX(D1, S, P) =
     .     NORM1 * (2.0D0 * D1 + SQRT5 * S) + LDIST * P

      XY(D1, P) =
     .   NORM2 * D1 + LDIST * P
