C ********************************************************************
C * EDiT - Electronic Dipole-induced Transitions                     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE READWA                                               *
C *                                                                  *
C *  Routine of EDiT/CEDiT                                           *
C *  version for IBM-PC MS-DOS, Microsoft FORTRAN and                *
C *              IBM-RISC UNIX, AIX XL FORTRAN                       *
C *                                                                  *
C *  Usage......: Opens *gen and *mo files. Wavefunctions, atomic    *
C *               coordinates are taken from the *.mo file while     *
C *               the Slater exponents are read from *.gen           *
C *                                                                  *
C *  Authors....: Ruedi Rytz                                         *
C *                                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: June 1992                                          *
C *  Revision...: June 1993/rr                                       *
C *               October 1995/rr                                    *
C *                                                                  *
C *  Called from: GETSEL                                             *
C *                                                                  *
C *  Calls......: MATRIX, WRITEL                                     *
C *                                                                  *
C ********************************************************************

      SUBROUTINE READWA(GENFIL, MOFIL, MATRIC, POLARR, NPSII, RPSII,
     .                  NPSIF, RPSIF, TOL, KEYWRD, DIM, NEIGH, KSTART,
     .                  KEND)

      IMPLICIT NONE

      INCLUDE 'sizes'
      INCLUDE 'edconst.inc'

        CHARACTER*16         GENFIL, MOFIL, MATRIC
        CHARACTER*3          POLARR 
        INTEGER              NPSII, RPSII, NPSIF, RPSIF
        DOUBLE PRECISION     TOL
        CHARACTER*(4*RECLEN) KEYWRD
        DOUBLE PRECISION     DIM(3,3)
        INTEGER              NEIGH(3), KSTART, KEND

C VAR
      COMMON /TRANS/WAVNUM(MAXTRA), OSCX(MAXTRA),
     .              OSCY(MAXTRA), OSCZ(MAXTRA), DEGEN(MAXAO),
     .              COUNTER, INMO(MAXTRA), FIMO(MAXTRA)

      COMMON /IOUNIT/IIN, IOUT, ISTART(40)
      INTEGER IIN, IOUT, ISTART

      DOUBLE PRECISION WAVNUM, OSCX, OSCY, OSCZ
      INTEGER DEGEN, COUNTER
      INTEGER INMO, FIMO

      CHARACTER*1        POL
      CHARACTER*(RECLEN) REC
      CHARACTER*2        SYMB(MAXATO), SYMBOL(MAXATO)
      CHARACTER*(RECLEN) STRING
      CHARACTER*12       SPCFIL
      CHARACTER*4        EXTENS

      INTEGER  FEHLER, ANZAO
      INTEGER  NUM, ANZATO
      INTEGER  I, J, N, P, K, POLCO
      INTEGER  FAO(MAXATO), LAO(MAXATO)
      INTEGER  NS(MAXATO), NP(MAXATO), ND(MAXATO)
      INTEGER  POINTER(MAXATO), STRLEN, RSTART, REND 
      INTEGER  IMOFI, IGENFI, ISPEC

      DOUBLE PRECISION MPSII(MAXAO,MAXAO), MPSIF(MAXAO,MAXAO)
      DOUBLE PRECISION CMPSII(MAXAO,MAXAO), CMPSIF(MAXAO,MAXAO)
      DOUBLE PRECISION PSII(MAXAO), PSIF(MAXAO), CPSII(MAXAO) 
      DOUBLE PRECISION CPSIF(MAXAO)
      DOUBLE PRECISION MEPSII(MAXAO), MEPSIF(MAXAO)
      DOUBLE PRECISION DUMMY(MAXAO)
      DOUBLE PRECISION X(MAXATO), Y(MAXATO), Z(MAXATO)
      DOUBLE PRECISION EXPS(MAXATO), EXPP(MAXATO), EXPD1(MAXATO)
      DOUBLE PRECISION EXPD2(MAXATO), C1(MAXATO), C2(MAXATO)
      DOUBLE PRECISION OVERLP, NORM, DELTAE, KP(3), WEIGHT


      LOGICAL GOTE1, GOTE2, GPSII, GPSIF, ZDO, CRYST, KPE

      PARAMETER(EXTENS='.kpe')

C BEGIN
      IMOFI = 1
      IGENFI = 2
      ISPEC = 3
      KPE=.FALSE.

      IF (INDEX(MATRIC,'ALL') .NE. 0) THEN
        ZDO = .FALSE.
      ELSEIF (INDEX(MATRIC,'BDIAG') .NE. 0) THEN
        ZDO = .TRUE.
      ENDIF

      CRYST = (INDEX(KEYWRD,'CRYST') .GT. 0)

      OPEN ( UNIT = IGENFI, FILE = GENFIL, ACCESS = 'SEQUENTIAL',
     .       FORM = 'FORMATTED', STATUS = 'OLD',
     .       IOSTAT = FEHLER)

      IF (FEHLER .GT. 0) THEN
        STRING = ' Error opening '//GENFIL(1:STRLEN(GENFIL,' '))//'.'
        CALL WRITEL(STRING,.TRUE.)
      ENDIF

70    CONTINUE
        READ (IGENFI, '(A)' ) REC
      IF (REC(1:2) .NE. ' *') GOTO 70

      I=0
80    CONTINUE
        DO 83 J = 1, 40
          READ (REC, '(A2)' ) SYMB(I+1)
          IF (SYMB(I+1) .NE. '  ') I=I+1
          REC = REC(3:)
83      CONTINUE
        READ (IGENFI, '(A)' ) REC
        N=0
          DO 84 J=1, 3
            IF ( (ICHAR(REC(2+J:2+J)) .LT. ICHAR('A')) .OR.
     .           (ICHAR(REC(2+J:2+J)) .GT. ICHAR('Z')) ) N=N+1
84        CONTINUE
        IF (N .LT. 3) GOTO 80
        BACKSPACE(IGENFI)

      ANZATO=I

      J = 1
      DO 85 I = 1, ANZATO
        IF ( SYMB(I) .EQ. ' *' ) THEN
          READ (IGENFI, '(A2, 3X, 3(I3, F6.3, 6X), F6.4, F6.3, F6.4 )')
     .     SYMBOL(J) ,NS(J), EXPS(J), NP(J), EXPP(J), ND(J), EXPD1(J),
     .     C1(J), EXPD2(J), C2(J)
           SYMB(I) = SYMBOL(J)
          J = J + 1
        ENDIF
85    CONTINUE

      CLOSE (IGENFI, STATUS ='KEEP')

      DO 90 I = 1, ANZATO
        DO 100 N = 1, J - 1
          IF (SYMB(I) .EQ. SYMBOL(N)) THEN
            POINTER(I) = N
          ENDIF
100     CONTINUE
90    CONTINUE

C Normierung der C1 und C2 Werte

      DO 110 I = 1, ANZATO
        J = POINTER(I)
        IF (C2(J) .NE. 0.0D0) THEN
          OVERLP = (4.0D0 * EXPD1(J) * EXPD2(J)/(EXPD1(J)
     .              + EXPD2(J))**2.0D0)**(ND(J)+5.0D-1)
          NORM = 1.0D0/SQRT(C1(J)**2.0D0 + C2(J)**2.0D0 +
     .                      2.0D0*OVERLP*C1(J)*C2(J))
          C1(J)=NORM*C1(J)
          C2(J)=NORM*C2(J)
        ENDIF
110   CONTINUE

C Ende der Normierung

      DO 5 K = KSTART, KEND 

        IF ( KSTART .NE. 0 ) THEN
          WRITE(MOFIL, '(I3.3,A)' ) K, EXTENS
          KPE=.TRUE. 
        ENDIF
      
        OPEN ( UNIT = IMOFI, FILE = MOFIL, ACCESS = 'SEQUENTIAL',
     .         FORM = 'FORMATTED', STATUS = 'OLD',
     .         IOSTAT = FEHLER)

        IF (FEHLER .GT. 0) THEN 
          STRING = ' Error opening '//MOFIL(1:STRLEN(MOFIL,' '))//'.'
          CALL WRITEL(STRING,.TRUE.)
        ENDIF

        IF ( KPE ) THEN
          READ (IMOFI, '(A)') REC
          READ (IMOFI, '(4(1X,F11.8))' ) (KP(J),J=1,3), WEIGHT
          READ (IMOFI, ' (I3) ' ) ANZAO
        ELSE
          READ (IMOFI, '(A)') REC
          READ (IMOFI, '(A)') REC
          READ (IMOFI, ' (I3) ' ) ANZAO
          READ (IMOFI, '(A)') REC
          READ (IMOFI, '(A)') REC
          WEIGHT=1.0D0
        ENDIF

C If we do not want to distinguish explicitly between Crystal and Molecular
C Calculations. Hence WEIGHT is set to 1 for molecules!

C (* Einlesen der Energiewerte der Ausgangs- und Endwellenfunktion *)

        GOTE1 = .FALSE.
        GOTE2 = .FALSE.
        RSTART = NPSII
        REND   = NPSII

C We determine the DEGENERACY of the wave functions regardless of the
C KEYWRDs specified!

20      CONTINUE
          READ (IMOFI, ' (A) ', END = 500) REC
          IF ( INDEX(REC,'EH') .GT. 0 ) GOTO 500
          READ (REC, ' (I3) ') NUM
          IF (NUM .EQ. NPSII) THEN
            READ (REC, ' (4X ,E13.7E2) ') MEPSII(NPSII)
            IF (RPSII .GE. NPSII) THEN
              DO 22 J = NPSII + 1, RPSII
                READ (IMOFI, ' (A) ', END = 600) REC
                IF ( INDEX(REC,'EH') .GT. 0 ) GOTO 600
                READ (REC, ' (4X ,E13.7E2) ') MEPSII(J)

                IF ( DABS(MEPSII(J) - MEPSII(J-1)) .LE. TOL ) THEN
                  REND = REND + 1
                ELSE
                  DO 21 I = RSTART,REND
                    DEGEN(I) = REND-RSTART+1 
21                CONTINUE
                  RSTART=J
                  REND=J
                ENDIF
22            CONTINUE

              DO 29 I = RSTART,REND
                DEGEN(I) = REND-RSTART+1
29            CONTINUE
            ENDIF

            GOTE1 = .TRUE.
          ENDIF

          IF (NUM .EQ. NPSIF) THEN
            READ (REC, ' (4X ,E13.7E2) ') MEPSIF(NPSIF)
            IF (RPSIF .GT. NPSIF) THEN
              DO 24 J = NPSIF + 1, RPSIF
                READ (IMOFI, ' (A) ', END = 500) REC
                IF ( INDEX(REC,'EH') .GT. 0 ) GOTO 600
                READ (REC, ' (4X ,E13.7E2) ') MEPSIF(J)
24            CONTINUE
            ENDIF
            GOTE2 = .TRUE.
          ENDIF

        IF (.NOT. GOTE1 .OR. .NOT. GOTE2) GOTO 20

C (* Ende Einlesen der Energiewerte                                *)

C (* Einlesen der Atomkoordinaten                                  *)

25      CONTINUE
          READ (REC, ' (I3) ') NUM
        IF (NUM .LT. ANZAO) THEN
          READ (IMOFI, ' (A) ') REC
          GOTO 25
        ENDIF

        READ (IMOFI, ' (I3) ' ) ANZATO
 
        DO 28 I = 1, ANZATO
          READ (IMOFI, ' (3X, 3(1X, E13.7E2) ) ')  X(I), Y(I), Z(I)
28      CONTINUE

C (* Ende Einlesen der Atomkoordinaten                             *)

C (* Ueberlesen der Konnektivitaeten                               *)

        IF ( .NOT. KPE ) THEN

          READ (IMOFI, ' (I3) ' ) NUM
          DO 32 I = 1, NUM
            READ (IMOFI, ' (A) ' ) REC
32        CONTINUE

        ENDIF

C (* Ende Ueberlesen der Konnektivitaeten                          *)

C (* Einlesen der Zugehoerigkeit der AO's zu den Atomen            *)
        READ (IMOFI, ' (A) ' ) REC
        READ (IMOFI, ' (A) ' ) REC

        DO 50 I = 1, ANZATO
          READ (IMOFI, ' (A) ' ) REC
          READ (IMOFI, ' ( 2(I3) ) ' ) FAO(I), LAO(I)
50      CONTINUE
C (* Ende Einlesen der Zugehoerigkeit der AO's zu den Atomen       *)

C (* Lesen der Wellenfunktionen                                    *)
        GPSII = .FALSE.
        GPSIF = .FALSE.

60    CONTINUE
        READ (IMOFI, ' (A) ') REC
        READ (REC, ' (10X, I3) ', ERR = 60) NUM
 
        IF (NUM .EQ. NPSII) THEN
          READ (IMOFI, ' ( 10(1X, F7.4) ) ') 
     .         (MPSII(NPSII,I), I=1,ANZAO)
          IF ( CRYST ) THEN
            READ (IMOFI, ' ( 10(1X, F7.4) ) ')
     .           (CMPSII(NPSII,I), I=1,ANZAO)
          ENDIF
          IF (RPSII .GT. NPSII) THEN
            DO 65 P = NPSII + 1, RPSII
              IF (MOD(ANZAO,10) .EQ. 0) THEN
                READ (IMOFI, ' (A) ', END = 500) REC
              ENDIF
              READ (IMOFI, ' (A) ' ) REC
              READ (IMOFI, ' ( 10(1X, F7.4) ) ') 
     .             (MPSII(P,I), I=1,ANZAO)
              IF ( CRYST ) THEN
                READ (IMOFI, ' ( 10(1X, F7.4) ) ')
     .               (CMPSII(P,I), I=1,ANZAO)
              ENDIF 
65          CONTINUE
          ENDIF
          GPSII = .TRUE.

        ELSE IF (NUM .EQ. NPSIF) THEN

          READ (IMOFI, ' ( 10(1X, F7.4) ) ') 
     .         (MPSIF(NPSIF,I), I=1,ANZAO)
          IF ( CRYST ) THEN
            READ (IMOFI, ' ( 10(1X, F7.4) ) ')
     .           (CMPSIF(NPSIF,I), I=1,ANZAO)
          ENDIF         
          J = ABS(RPSIF - NPSIF)
          IF (RPSIF .GT. NPSIF) THEN
            DO 68 P = NPSIF + 1, RPSIF
              IF (MOD(ANZAO,10) .EQ. 0) THEN
                READ (IMOFI, ' (A) ', END = 500) REC
              ENDIF
              READ (IMOFI, ' (A) ' ) REC
              READ (IMOFI, ' ( 10(1X, F7.4) ) ') 
     .             (MPSIF(P,I), I=1,ANZAO)
              IF ( CRYST ) THEN
                READ (IMOFI, ' ( 10(1X, F7.4) ) ')
     .             (CMPSIF(P,I), I=1,ANZAO)                
              ENDIF
68          CONTINUE
          ENDIF
          GPSIF = .TRUE.

        ELSE

          READ (IMOFI, ' ( 10(1X, F7.4) ) ') (DUMMY(I), I=1,ANZAO)
          IF ( CRYST ) THEN
            READ (IMOFI, ' ( 10(1X, F7.4) ) ') (DUMMY(I), I=1,ANZAO)
          ENDIF

        ENDIF

        IF (MOD(ANZAO,10) .EQ. 0) THEN
          READ (IMOFI, ' (A) ', END = 500) REC
        ENDIF

      IF (.NOT. GPSII .OR. .NOT. GPSIF) GOTO 60

      CLOSE (IMOFI, STATUS ='KEEP')
C (* Ende Lesen der Wellenfunktionen                               *)

      IF (INDEX(KEYWRD,'SPECOUT') .GT. 0) THEN
        COUNTER = 0
        DO 115 I = 1, MAXTRA
          INMO(I) = 0
          FIMO(I) = 0
          WAVNUM(I) = 0.0D0
          OSCX(I) = 0.0D0
          OSCY(I) = 0.0D0
          OSCZ(I) = 0.0D0 
115     CONTINUE
      ENDIF

      DO 120 I = NPSII, RPSII
        DO 130 J = NPSIF, RPSIF
C
C The COUNTER is incremented even if KEYWRD SPECOUT is not wished.
C This is faster than checking for INDEX(KEYWRD,'SPECOUT') in every loop.
C
          COUNTER = COUNTER + 1

          DO 140 N = 1, ANZAO
            PSII(N) = MPSII(I,N)
            PSIF(N) = MPSIF(J,N)
140       CONTINUE

          IF ( CRYST ) THEN
            DO 145 N = 1, ANZAO
              CPSII(N) = CMPSII(I,N)
              CPSIF(N) = CMPSIF(J,N)
145         CONTINUE
          ENDIF

          POLCO = 1
          POL = POLARR(POLCO:POLCO)

          IF (INDEX(KEYWRD,'TRANSOUT') .GT. 0) THEN
            WRITE(IOUT, '(A)' )
            IF (INDEX(KEYWRD,'CRYST') .GT. 0) THEN
              WRITE(IOUT, '(A5,I3.3,A,3(F7.4))' ) ' KP #', K,
     .             ' ...................: ', KP(1), KP(2), KP(3)
            ENDIF
            WRITE(IOUT, '(A, I3)' ) ' Initial wave function .....: ',
     .            I
            WRITE(IOUT, '(A, I3)' ) ' Final wave function .......: ',
     .            J
            WRITE(IOUT, '(A, F8.1, A, F4.1, A)' ) 
     .            ' Transition at .............: ',
     .            DELTAE(MEPSII(I), MEPSIF(J)) * CM, ' Wavenumbers (', 
     .            DELTAE(MEPSII(I), MEPSIF(J)),' eV )'
          ENDIF


150       CONTINUE

            CALL MATRIX(PSII, CPSII, PSIF, CPSIF, ANZAO, ANZATO,
     .                  X, Y, Z, FAO, LAO, POL, NS, NP, ND,
     .                  POINTER, EXPS, EXPP, EXPD1, EXPD2,
     .                  C1, C2, ZDO, MEPSII(I), MEPSIF(J), I, J,
     .                  KEYWRD, DIM, NEIGH, KP, WEIGHT)

            POLCO = POLCO + 1
            IF (POLCO .LE. 3) POL = POLARR(POLCO:POLCO)

          IF (POL .NE. ' ' .AND. POLCO .LE. 3) GOTO 150

130     CONTINUE
120   CONTINUE

      IF ( INDEX(KEYWRD,'SPECOUT') .GT. 0 ) THEN
        SPCFIL = MOFIL(1:INDEX(MOFIL,'.'))//'eds'
        OPEN (UNIT = ISPEC, FILE = SPCFIL, ACCESS = 'SEQUENTIAL',
     .        FORM = 'FORMATTED', STATUS = 'UNKNOWN', 
     .        IOSTAT = FEHLER)

        IF (FEHLER .GT. 0) THEN
          STRING = ' Error opening '//SPCFIL//'.'
          CALL WRITEL(STRING,.TRUE.)
        ENDIF 

        CALL SPECOUT(ISPEC, TOL)

        CLOSE (ISPEC, STATUS = 'KEEP')
      ENDIF
  
5     CONTINUE ! KSTART, KEND

      RETURN

500   CONTINUE
        IF ( .NOT. GOTE1 )  THEN
          WRITE(STRING,' (A,I4,A) ') ' Wave function ',NPSII, 
     .                               ' not found.' 
          CALL WRITEL(STRING,.TRUE.) 
        ELSE
          WRITE(STRING,' (A,I4,A) ') ' Wave function ',NPSIF,
     .                               ' not found.'
          CALL WRITEL(STRING,.TRUE.)
        ENDIF

600   CONTINUE
        IF ( .NOT. GOTE1 ) THEN
          WRITE(STRING,' (A,I4,A) ') ' Wave function ',RPSII,
     .                               ' not found.'
          CALL WRITEL(STRING,.TRUE.)
        ELSE
          WRITE(STRING,' (A,I4,A) ') ' Wave function ',RPSIF,
     .                               ' not found.'
          CALL WRITEL(STRING,.TRUE.)
        ENDIF
      END
C END
