C ********************************************************************
C * EDiT - Electronic Dipole-induced Transitions                     *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE SOSELE                                               *
C *                                                                  *
C *  Routine of EDiT/CEDiT                                           *
C *  version for IBM-PC MS-DOS, Microsoft FORTRAN and                *
C *              IBM-RISC UNIX, AIX XL FORTRAN                       * 
C *                                                                  *
C *  Usage......: Calculates the <s|O|s> transition elements of the  *
C *               transition matrix.                                 *
C *                                                                  *
C *  Authors....: Ruedi Rytz                                         *
C *                                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: July 1992                                          *
C *  Revision...: -                                                  *
C *                                                                  *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: OBDIAG                                             *
C *                                                                  *
C *  Calls......: ABFNS                                              *
C *               LOVLAP                                             *
C *               SPOVL                                              *
C *                                                                  *
C ********************************************************************

      SUBROUTINE SOSELE(M, HQZ, N2, SK1, SK2, R,
     .                  PTR, LDIST, POL)

      IMPLICIT NONE

      DOUBLE PRECISION  M
      INTEGER           HQZ, N2 
      DOUBLE PRECISION  SK1, SK2, R, PTR(9), LDIST
      CHARACTER*1       POL

C VAR
      INTEGER   L1, L2, ML, MAX, N1
      DOUBLE PRECISION  A(20), B(20), SSOS, PSOS, PSO(3), NORM

      INCLUDE 'snorm.inc'

C BEGIN

C Berechne den "normalen" s-s-Overlap

      N1 = HQZ

      L1 = 0
      L2 = 0
      ML = 0
      MAX = N1 + N2

      CALL ABFNS(A, B, SK1, SK2, R, MAX)
      CALL LOVLAP(SSOS, A, B, SK1, SK2, R, L1, L2,
     .            ML, N1, N2)

C SSOS bedeut s-s-sigma-Overlap

      N1 = N1 + 1
      L1 = 1
      MAX = N1 + N2

C Die Slaterexponenten aendern sich nicht.

      CALL ABFNS(A, B, SK1, SK2, R, MAX)
      CALL LOVLAP(PSOS, A, B, SK1, SK2, R, L1, L2,
     .            ML, N1, N2)

      PSOS = - PSOS

      CALL SPOVL(PSO, PSOS, PTR)

        IF (POL .EQ. 'X') THEN
          M = M * (NORM * PSO(1) + LDIST * SSOS)
        ELSE IF (POL .EQ. 'Y') THEN
          M = M * (NORM * PSO(2) + LDIST * SSOS)
        ELSE
          M = M * (NORM * PSO(3) + LDIST * SSOS)
        ENDIF
      
      RETURN
      END
C END
