! ********************************************************************
! * GOP - Graphic Optimization Program for EHMO ICONC                *
! *                                                                  *
! * Copyright (C) 1997 by Gion Calzaferri                            *
! *                                                                  *
! * This program is free software; you can redistribute it and/or    *
! * modify it under the terms of the GNU General Public License as   *
! * published by the Free Software Foundation; Version 2 of the      *
! * License.                                                         *
! *                                                                  *
! * This program is distributed in the hope that it will be useful,  *
! * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
! * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
! * General Public License for more details.                         *
! *                                                                  *
! * You should have received a copy of the GNU General Public        *
! * License along with this program; if not, write to the Free       *
! * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
! * MA 02111-1307 USA                                                *
! ********************************************************************


!------------------------------------------------------------------------------
! PROJECT : GOP                                            by Roman Calzaferri
!------------------------------------------------------------------------------
! FILENAME      : GOP_MAIN.f90
! AUTHOR        : Roman Calzaferri
! DATE          : 8. September 1997
! LAST MODIFIED : 12. September 1997
!------------------------------------------------------------------------------
! CONTENTS : Main program for the project
!------------------------------------------------------------------------------
! USED BY  : -
!------------------------------------------------------------------------------
! USES     : GENFILE_TYPE, file GENFILE_TYPE.f90
!            SEARCH_EMIN,  file SEARCH_EMIN_S.f90
!------------------------------------------------------------------------------


PROGRAM GOP
   USE GENFILE_TYPE
   USE SEARCH_EMIN
   IMPLICIT NONE

   ! -----------------------------------
   CHARACTER(LEN=50) :: GENFILENAME
   TYPE(GENFILE) A_TEST
   INTEGER ERROR

   ! -----------------------------------
   WRITE(*,'(//,20(A,/))')                                                     &
     '  ***********************************************************', &
     '  *                    I C O N - E D i T                    *', &
     '  *                  Release September 1997                 *', & 
     '  *                          G O P                          *', &
     '  *  -----------------------------------------------------  *', &
     '  *      Graphic Optimization Program for EHMO ICONC        *', &
     '  *              written by Roman Calzaferri                *', &
     '  *      using a simplex algorithm written by D. E. Shaw    *', &
     '  *                  (Lindfield, AUS) et al.                *', &
     '  *                          -----                          *', &
     '  *      Gion Calzaferri, Ruedi Rytz, Martin Braendle,      *', &
     '  *          Dominik Bruehwiler and Stephan Glaus           *', &
     '  *        Department of Chemistry and Biochemistry         *', &
     '  *             University of Bern, Switzerland             *', &
     '  *                                                         *', &
     '  *               (C) 1997 by Gion Calzaferri               *', &
     '  *   GOP comes with absolutely no warranty. This is free   *', &
     '  *     software and you are welcome to redistribute it     *', &
     '  *                under certain conditions.                *', &
     '  *       For details see GNU General Public License.       *', &
     '  ***********************************************************'


   WRITE(*, '(//,A)', ADVANCE = 'NO') ' Filename .gen without extension: '

   READ*, GENFILENAME
   CALL ADD_EXTENSION(GENFILENAME)

   CALL INIT(A_TEST, GENFILENAME, ERROR)
   IF (ERROR /= 0) THEN
      WRITE(*,*) 'ERROR READING/WRITING ', GENFILENAME

   ELSE
      CALL SEARCH_EMIN_START(A_TEST)

      CALL CLEANUP(A_TEST)
   END IF

   ! -----------------------------------
   CONTAINS
      SUBROUTINE ADD_EXTENSION(FILENAME)
         CHARACTER(LEN=*), INTENT(INOUT)      :: FILENAME
         INTEGER FNLENGTH

         FNLENGTH = LEN_TRIM(FILENAME)

         FILENAME(FNLENGTH+1:FNLENGTH+4) = '.gen'
      END SUBROUTINE ADD_EXTENSION
      ! -----------------------------------
      ! -----------------------------------


END PROGRAM GOP
! -----------------------------------
! end of file
! -----------------------------------

