C ********************************************************************
C * ICONC - Extended Hueckel Calculations                            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE LITER                                                *
C *                                                                  *
C *  Routine of ICONC(S)                                             *
C *                                                                  *
C *  Usage......: Calculates Q*SENSE when using charge iteration op- *
C *               tion (METH = 1).                                   *
C *                                                                  *
C *  Authors....: -                                                  *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: -                                                  *
C *  Revision...: last revision 17.11.90/mbs (Martin Braendle)       *
C *  Remarks....: Arrays X,Y,Z changed to HSS,HPP,HDD.               *
C *                                                                  *
C *  Called from: OUTPUT                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE LITER(NH,NA,E,W,NCYC)
 
      INCLUDE 'iconpara.for'
 
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION E(1),W(1)
 
      COMMON /ATOM/EXPS(MXATOM),EXPP(MXATOM),EXPD(MXATOM),EXPD2(MXATOM),
     .             C1(MXATOM),C2(MXATOM),COULS(MXATOM),COULP(MXATOM),
     .             COULD(MXATOM),X(MXATOM),Y(MXATOM),Z(MXATOM),
     .             KEY(MXATOM),AC(MXATOM),VELEC(MXATOM),NS(MXATOM),
     .             NP(MXATOM),ND(MXATOM)
      INTEGER AC,VELEC,KEY
 
      COMMON/ENERGY/HSS(MXATOM),HPP(MXATOM),HDD(MXATOM)
 
      COMMON/ITPARM/DAMP1,DAMP2,DAMP3,LAMPRI,DELTAC,SENSE,MAXCYC,
     .              PRTCYC,ICYCLE,NCON,PARTIT,PRINTX,ITABLE(MXITER)
      REAL*8 LAMPRI
      LOGICAL*1 PARTIT,PRINTX,ITABLE
      INTEGER*4 PRTCYC
 
      COMMON /STARS/STAR,STAR2,SYMBOL(MXATOM)
      CHARACTER*2 STAR,STAR2,SYMBOL

      NCYC=ICYCLE+1-(ICYCLE/4)*4
      ICYCLE=ICYCLE+1
      DELTA=0.D0
      NATOM=NH+NA
      INDEX=1
      DO 60 I=1,NATOM
        INCR=1
        IF (I.GT.NH) GOTO 100
        CHG=1.0D0-E(INDEX)
        GOTO 150
100     KEYI=KEY(I-NH)
        CHG=E(INDEX)
        IF (ND(KEYI).EQ.0) GOTO 120
        INCR=9
        CHG=CHG+E(INDEX+4)+E(INDEX+5)+E(INDEX+6)+E(INDEX+7)+E(INDEX+8)
        GOTO 130
120     IF (NP(KEYI).EQ.0) GOTO 140
        INCR=4
130     CHG=CHG+E(INDEX+1)+E(INDEX+2)+E(INDEX+3)
140     CHG=VELEC(KEYI)-CHG
150     INDEX=INDEX+INCR
        GOTO (10,20,30,40),NCYC
10      CHG=0.25D0*(CHG+HPP(I)+HDD(I)+W(I))
        HSS(I)=CHG
        HPP(I)=CHG
        HDD(I)=CHG
        W(I)=CHG
        GOTO 60
20      DELTA=DELTA+DABS(CHG-HSS(I))
        HPP(I)=CHG
        GOTO 60
30      DELTA=DELTA+DABS(CHG-HPP(I))
        HDD(I)=CHG
        GOTO 60
40      DELTA=DELTA+DABS(CHG-HDD(I))
        W(I)=CHG
60      E(I)=CHG*SENSE
      IF (DELTAC.LT.DELTA.OR.NCYC.EQ.1) RETURN
      ICYCLE=15000
      RETURN
      END
