C ********************************************************************
C * ICONC - Extended Hueckel Calculations                            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE MATOUT                                               *
C *  SUBROUTINE OVMAT                                                *
C *                                                                  *
C *  Routine of ICONC                                                *
C *                                                                  *
C *  Usage......: print out fragment matrices.                       *
C *                                                                  *
C *  Authors....: Charles Wilker (R. Hoffmann group)                 *
C *               Sunil Wijeyesekera (R. Hoffmann group)             *
C *  Date.......: December 1981, February 1983                       *
C *  Revision...: last revision 24.08.97/mbs (Martin Braendle)       *
C *  Available..: Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *  Remarks....: Adapted from the subroutines OUTMAT and OVMAT of   *
C *               BIGICON.                                           *
C *                                                                  *
C *  Called from: FMOSRT,OUTPUT                                      *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE MATOUT(A,N,NC)
 
      INCLUDE 'iconpara.for'
 
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION A(N,N)
 
      COMMON/FMO/FMO(MXATOM),FMOCH(9),SORA(MXATOM),SORB(MXATOM),
     .           NFRAG(9),NUMBAT(9),IFMOPT(4*MXATOM),IBCKPT(MXATOM),
     .           PRIFMO(7)
      INTEGER FMO,FMOCH,SORA,SORB
      LOGICAL*1 PRIFMO

      KITE=0
      GOTO 10
 
      ENTRY OVMAT(A,N,NC)
      KITE=SORB(2)-1
10    NROW=N
      NCOL=NC
20    LOW=KITE+1
      KITE=KITE+14
      IF (KITE.GT.NCOL) KITE=NCOL
      WRITE(6,1000) (I,I=LOW,KITE)
1000  FORMAT(/,11X,14I8)
 
      IW=0
      DO 30 I=1,NROW
        IF (SORB(IW+1).GT.I) GOTO 25
        IW=IW+1
        WRITE(6,1002) IW,(A(I,J),J=LOW,KITE)
1002    FORMAT(/,2X,'FRAG ',I1,'(  1)',14F8.4)
        GOTO 30
25      K=I-SORB(IW)+1
        WRITE(6,1003) K,(A(I,J),J=LOW,KITE)
1003    FORMAT(8X,'(',I3,')',14F8.4)
30    CONTINUE
      IF (KITE.LT.NCOL) GOTO 20
      WRITE(6,1001)
1001  FORMAT(/)
      RETURN
      END
