C ********************************************************************
C * ICONC - Extended Hueckel Calculations                            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SURBROUTINE OUTPEG                                              *
C *                                                                  *
C *  Routine of ICONC(S)                                             *
C *                                                                  *
C *  Usage......: Prints out matrices in readable format (with atom  *
C *               and ao symbols).                                   *
C *                                                                  *
C *  Author.....: Charles Wilker                                     *
C *  Date.......: December 1981                                      *
C *  Revision...: last revision 24.08.97/mbs (Martin Braendle)       *
C *  Available:   Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *  Remarks....: Adapted from BIGICON.                              *
C *                                                                  *
C *  Called from: OVPRT,HUCKEL,OUTPUT                                *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE OUTPEG(A,N,NC)
 
      INCLUDE 'iconpara.for'
 
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION A(N,N)
 
      COMMON /ATOM/EXPS(MXATOM),EXPP(MXATOM),EXPD(MXATOM),EXPD2(MXATOM),
     .             C1(MXATOM),C2(MXATOM),COULS(MXATOM),COULP(MXATOM),
     .             COULD(MXATOM),X(MXATOM),Y(MXATOM),Z(MXATOM),
     .             KEY(MXATOM),AC(MXATOM),VELEC(MXATOM),NS(MXATOM),
     .             NP(MXATOM),ND(MXATOM)
      INTEGER AC,VELEC,KEY
 
      COMMON/FMO/FMO(MXATOM),FMOCH(9),SORA(MXATOM),SORB(MXATOM),
     .           NFRAG(9),NUMBAT(9),IFMOPT(4*MXATOM),IBCKPT(MXATOM),
     .           PRIFMO(7)
      INTEGER FMO,FMOCH,SORA,SORB
      LOGICAL*1 PRIFMO
  
      COMMON /STARS/STAR,STAR2,SYMBOL(MXATOM)
      CHARACTER*2 STAR,STAR2,SYMBOL

      CHARACTER*10 ORB(16)
      DATA ORB/'S)        ','X)        ','Y)        ','Z)        ',
     .         'X2-Y2)    ','Z2)       ','XY)       ','XZ)       ',
     .         'YZ)       ',
     .         'Z3)       ','XZ2)      ','YZ2)      ','XYZ)      ',
     .         'Z(X2-Y2)) ','X(X2-3Y2))','Y(3X2-Y2))'/
 
      NROW=N
      NCOL=NC
      KITE=0
20    LOW=KITE+1
      KITE=KITE+14
      IF(KITE.GT.NCOL) KITE=NCOL
      WRITE(6,1000) (I,I=LOW,KITE)
1000  FORMAT(/,16X,14I8)
 
      IW=0
      DO 30 I=1,NROW
        IF (SORB(IW+1).GT.I) GOTO 25
        IW=IW+1
        IWH=KEY(IW)
        WRITE(6,1002) SYMBOL(IWH),IW,ORB(1),(A(I,J),J=LOW,KITE)
1002    FORMAT(/,2X,A2,I3,'(',A10,14F8.4)
        GOTO 30
25      K=I-SORB(IW)+1
        WRITE(6,1003) ORB(K),(A(I,J),J=LOW,KITE)
1003    FORMAT(7X,'(',A10,14F8.4)
30    CONTINUE
      IF (KITE.LT.NCOL) GOTO 20
      WRITE(6,1004)
1004  FORMAT(/)
      RETURN
      END
