C ********************************************************************
C * ICONC - Extended Hueckel Calculations                            *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE OVPRT                                                *
C *                                                                  *
C *  Routine of ICONC                                                *
C *                                                                  *
C *  Usage......: prints distance, overlap and madelung matrices.    *
C *                                                                  *
C *  Authors....: Charles Wilker                                     *
C *  Available..: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: 29.10.90, by Martin Braendle (mbs)                 *
C *  Revision...: last revision 17.10.91/mbs/Hae (Konrad Haedener)   *
C *  Remarks....: adapted from subroutine MOVLAP from ICONC respec-  *
C *               tively subroutine OVPRT (BIGICON) by Charles Wil-  *
C *               ker.                                               *
C *                                                                  *
C *  Called from: MOVLAP                                             *
C *               FMOR                                               *
C *                                                                  *
C *  Calls......: OUTPEG                                             *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE OVPRT(S,MAD,C, NDIM,NC,NATOM,NTYPE,FLAG)
 
      IMPLICIT REAL*8(A-H,O-Z)
 
      DIMENSION S(NDIM,NDIM),MAD(NTYPE,NTYPE),C(NC)
      REAL*8 MAD
      LOGICAL*1 FLAG
 
      COMMON/CNTRL/CON,PEEP,COULH,NH,NA,NATM,KA,NELEC,METH,
     . IPRINT,IPUNCH,L1,L2,L3,L4,L5,L6,L7,L8,L9,ONEMAT,ITERAT
      LOGICAL*1 L1,L2,L3,L4,L5,L6,L7,L8,L9,ONEMAT,ITERAT
 
      COMMON/OUT/PRT(24),PUN(24),IOVPOP(24),IENRGY(24)
      LOGICAL*1 PRT,PUN
      INTEGER IOVPOP,IENRGY
 
 
C
C  SET UP DISTANCE MATRIX FOR PRINTING.
C  STUFF ELEMENTS OF S INTO C TO GET THEM OUT OF THE WAY.
C
450   ISUB=1
C
C  ZERO DISTANCE ALONG DIAGONAL.
C
      S(1,1)=0.D0
      DO 1010 I=2,NATOM
        S(I,I)=0.D0
        IM1=I-1
        DO 1005 J=1,IM1
          C(ISUB)=S(J,I)
          ISUB=ISUB+1
1005      S(J,I)=S(I,J)
1010  CONTINUE
 
      IF (PRT(3)) GOTO 2004
      WRITE(6,2000)
2000  FORMAT('0DISTANCE MATRIX')
      CALL PEGLEG(S,NATOM,NDIM)
2004  IF (PUN(3)) WRITE(7,2050) ((S(I,J),I=1,NATOM),J=1,NATOM)
2050  FORMAT(8F9.6)
C
C  SET UP OVERLAP MATRIX FOR PRINTING.
C  REPLACE ELEMENTS IN OVERLAP MATRIX FROM C.
C
1015  S(1,1)=1.D0
      ISUB=1
      DO 1025 I=2,NDIM
        S(I,I)=1.D0
        IM1=I-1
        DO 1020 J=1,IM1
          IF (I.GT.NATOM) GOTO 1020
          S(J,I)=C(ISUB)
          ISUB=ISUB+1
1020      S(I,J)=S(J,I)
1025  CONTINUE
C
C  If doing FMO save overlap matrix in scratch disk file.
C
      IF (L6.AND.FLAG) OPEN(UNIT=9,FORM='UNFORMATTED',STATUS='SCRATCH')
      IF (L6.AND.FLAG) WRITE(9) ((S(I,J),I=1,NDIM),J=1,NDIM)
 
      IF (PRT(4)) GOTO 2005
      WRITE(6,2001)
2001  FORMAT('0OVERLAP MATRIX')
      CALL OUTPEG(S,NDIM,NDIM)
2005  IF (PUN(4)) WRITE(7,2050) S
C
C  PRINT OUT MADELUNG PARAMETERS.
C
      IF (METH.LT.3) GOTO 460
      IF (PRT(5)) GOTO 2006
      WRITE(6,2002)
2002  FORMAT('0MADELUNG PARAMETERS')
      CALL PEGLEG(MAD,NTYPE,NTYPE)
2006  IF (PUN(5)) WRITE(7,2050) MAD
460   RETURN
      END
