C ********************************************************************
C * INPUTC - Input Program for ICONC                                 *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE INPFI                                                *
C *                                                                  *
C *  Routine of INPUTC                                               *
C *                                                                  *
C *  Usage......: Reads file name of input file.                     *
C *                                                                  *
C *  Authors....: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               Freiestrasse 3                                     *
C *               3012 Berne                                         *
C *                                                                  *
C *  Date.......: 07.12.89, by Thomas Hugentobler                    *
C *  Revision...: 15.10.91/mbs (Martin Braendle)                     *
C *  Remarks....: Option 'not used' removed.                         *
C *                                                                  *
C *  Called from: INPUTC                                             *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
C
      SUBROUTINE INPFI(IVA,FILE1,FILE2,FILE3)
      IMPLICIT REAL(A-H,O-Z)
 
      CHARACTER*32 FILE0,FILE1,FILE2,FILE3
      CHARACTER*4 EXTENS
 
      FILE0='                                '
      FILE1=FILE0
      FILE2=FILE0
      FILE3=FILE0
      IF (IVA .EQ. 1) EXTENS='.kar'
      IF (IVA .EQ. 2) EXTENS='.gen'
      IF (IVA .EQ. 3) EXTENS='.gen'
   10 WRITE(6,20) EXTENS
   20 FORMAT(/,' Filename',A4,' without extension: ',$)
      READ(5,30,ERR=10) FILE0
   30 FORMAT(A32)
      I=INDEX(FILE0,'.')
      IF (I .EQ. 0) THEN
        I=INDEX(FILE0,' ')
        I=I-1
      ENDIF
C
C Define Filenames FILE1 for CASE1
C  FILE1 and FILE2 for I/O of Subroutine GENIC
C  FILE2 and FILE3 for I/O of Subroutine CONVC
C
      FILE1=FILE0(1:I)//EXTENS
      FILE2='TEMP.VAR'
      FILE3='TEMP.KAR'
      RETURN
      END
