C ********************************************************************
C * INPUTC - Input Program for ICONC                                 *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE KOR                                                  *
C *                                                                  *
C *  Routine of INPUTC                                               *
C *                                                                  *
C *  Usage......: Reads cartesian atom coordinates                   *
C *                                                                  *
C *  Authors....: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               Freiestrasse 3                                     *
C *               3012 Berne                                         *
C *                                                                  *
C *  Date.......: 07.12.89                                           *
C *  Revision...: -                                                  *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: CASE1                                              *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE KOR(NA,SYMBOL)
      IMPLICIT REAL(A-H,O-Z)
 
      INCLUDE 'inpupara.for'
 
      CHARACTER*3 SYMBOL(MXSYMB)
 
      COMMON/KOORD/X(MXATOM),Y(MXATOM),Z(MXATOM)
 
      WRITE(6,10)
   10 FORMAT(/' X, Y and Z-coordinates, numbers with dec.point:',/)
   20 FORMAT(10X,' -----X----- -----Y----- -----Z-----',/,$,1X,A3,1X,
     .       I3,$,' : ')
   30 FORMAT(BN,3F12.8)
      DO 50 I=1,NA
   40   WRITE(6,20) SYMBOL(I),I
        READ(5,30,ERR=40) X(I),Y(I),Z(I)
   50 CONTINUE
      RETURN
      END
