C ********************************************************************
C * INPUTC - Input Program for ICONC                                 *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  OMITAT                                                          *
C *                                                                  *
C *  Routine of INPUTC,                                              *
C *                                                                  *
C *  Usage......: specifies atoms to be omitted from repulsion ener- *
C *               gy calculation.                                    *
C *                                                                  *
C *  Authors....: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               University of Berne                                *
C *               Freiestrasse 3                                     *
C *               CH-3012 Berne                                      *
C *                                                                  *
C *  Date.......: 22.06.91, by Martin Braendle (mbs)                 *
C *  Revision...: -                                                  *
C *  Remarks....: -                                                  *
C *                                                                  *
C *  Called from: PARAMET                                            *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE OMITAT
      IMPLICIT REAL(A-H,O-Z)
 
      INCLUDE 'inpupara.for'
 
      COMMON/OMITRP/NOMIT,OMIT(MXOMIT)
      INTEGER NOMIT,OMIT
 
      COMMON/PARAM/NH,NA,KA,METH,IPRINT,IPUNCH,L1,L2,L3,L4,L5,L6,L7,
     .             L8,L9,PRT
      LOGICAL L1,L2,L3,L4,L5,L6,L7,L8,L9,PRT(24)
 
      WRITE(6,10) MXOMIT
   10 FORMAT(//,' Specify atoms to be omitted from repulsion energy ',
     .          'calculation (max. ,',I3,').')
      WRITE(6,20)
   20 FORMAT(/,' Enter atom number. Exit with an empty line!')
   30 FORMAT(' Atom # : ',$)
   40 FORMAT(I3)
      NOMIT=1
   50 WRITE(6,30)
      READ(5,40,ERR=50) IATOM1
      IF (IATOM1 .GT. 0) THEN
        IF (IATOM1 .GT. NA) GO TO 50
        IF (NOMIT .GT. 1) THEN
          DO 60 I=1,NOMIT-1
            IF (IATOM1 .EQ. OMIT(I)) GOTO 50
   60     CONTINUE
        ENDIF
        OMIT(NOMIT)=IATOM1
        NOMIT=NOMIT+1
        IF ((NOMIT .LE. MXOMIT) .AND. (NOMIT .LE. NA)) GOTO 50
      ENDIF
      NOMIT=NOMIT-1
      L8=(NOMIT .NE. 0)
      RETURN
      END
