C ********************************************************************
C * INPUTC - Input Program for ICONC                                 *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE OUT                                                  *
C *                                                                  *
C *  Routine of INPUTC                                               *
C *                                                                  *
C *  Usage......: reads and sets output options                      *
C *                                                                  *
C *  Authors....: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               Freiestrasse 3                                     *
C *               3012 Berne                                         *
C *                                                                  *
C *  Date.......: 07.12.89                                           *
C *  Revision...: last revision 17.10.91/mbs (Martin Braendle)       *
C *                             15.05.92/rr  (Ruedi Rytz)            *
C *  Remarks....: COMMON block PARAM extended for FMO, k-parameter   *
C *               and omit-atom specification. /mbs                  *
C *               COMMON block PARAM changed. Addition of core-core  *
C *               repulsion enrgy matrix. 17.10.91/mbs               *
C *               MOBY output option added                           *
C *                                                                  *
C *  Called from: PARAMET                                            *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE OUT
 
      CHARACTER DUMMY
 
      COMMON/PARAM/NH,NA,KA,METH,IPRINT,IPUNCH,L1,L2,L3,L4,L5,L6,L7,
     .             L8,L9,PRT
      LOGICAL L1,L2,L3,L4,L5,L6,L7,L8,L9,PRT(24)
 
      IPRINT=3
      DO 10 I=1,21
        PRT(I)=.TRUE.
10    CONTINUE
      PRT(22)=.FALSE.
20    WRITE(6,30)
30    FORMAT(/5X,' Controlling output options:        '//
     . '   1  Coordinates and parameters       '/
     . '   3  Distance matrix                  '/
     . '   4  Overlap matrix                   '/
     . '   5  Madelung parameters              '/
     . '   6  Hueckel matrix                   '/
     . '   8  Energy levels                    '/
     . '   9  Total energy                     '/
     . '  10  Wavefunctions                    '/
     . '  11  Density matrix                   '/
     . '  12  Overlap population matrix        '/
     . '  13  Reduced overlap population matrix'/
     . '  14  Complete charge matrix           '/
     . '  15  Reduced charge matrix            '/
     . '  16  Net charges and populations      '/
     . '  17  Energy matrix                    '/
     . '  18  Reduced energy matrix            '/
     . '  19  Energy partitioning              '/
     . '  20  Reduced energy partitioning      '/
     . '  21  Core-core repulsion energy matrix'/
     . '  22  Moby output                      '/
     . '                                       '/
     . '  25  Exit                             '/)
40    WRITE(6,50)
50    FORMAT($,' Option # : ')
      READ(5,*,ERR=40) I
      IF (I.GT.22) GOTO 60
      IF (I.EQ.22) THEN
        PRT(I)=.TRUE.
        WRITE(6, '(/, 6(A, /)) ' )
     .  ' REMARKS:                                                    ',
     .  ' 1) If calculations have been performed for variing geometry ',
     .  '    MOBY output is only generated for the last one.          ',
     .  ' 2) MOBY output generates connectivity information that has  ',
     .  '    to be regarded as a proposal only and may have to be     ',
     .  '    changed/corrected by the users.                          '
        WRITE(6, '(A,$)' ) ' PRESS <RETURN> TO CONTINUE'
        READ(5, '(A1,$)' ) DUMMY
        GOTO 20
      ELSE
        PRT(I)=.FALSE.
      ENDIF
      GOTO 40
60    CONTINUE
      RETURN
      END
