C ********************************************************************
C * INPUTC - Input Program for ICONC                                 *
C *                                                                  *
C * Copyright (C) 1997 by Gion Calzaferri                            *
C *                                                                  *
C * This program is free software; you can redistribute it and/or    *
C * modify it under the terms of the GNU General Public License as   *
C * published by the Free Software Foundation; Version 2 of the      *
C * License.                                                         *
C *                                                                  *
C * This program is distributed in the hope that it will be useful,  *
C * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
C * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU *
C * General Public License for more details.                         *
C *                                                                  *
C * You should have received a copy of the GNU General Public        *
C * License along with this program; if not, write to the Free       *
C * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,   *
C * MA 02111-1307 USA                                                *
C ********************************************************************

C ********************************************************************
C *                                                                  *
C *  SUBROUTINE PAR                                                  *
C *                                                                  *
C *  Routine of INPUTC                                               *
C *                                                                  *
C *  Usage......: Reads number of atoms and charge of molecule.      *
C *                                                                  *
C *  Authors....: Calzaferri group c/o                               *
C *               Prof. Dr. Gion Calzaferri                          *
C *               Department of Chemistry and Biochemistry           *
C *               Freiestrasse 3                                     *
C *               3012 Berne                                         *
C *                                                                  *
C *  Date.......: 07.12.89                                           *
C *  Revision...: last revision 17.10.91/mbs (Martin Braendle)       *
C *  Remarks....: COMMON block PARAM extended./mbs                   *
C *                                                                  *
C *  Called from: CASE1                                              *
C *                                                                  *
C *  Calls......: -                                                  *
C *                                                                  *
C ********************************************************************
 
      SUBROUTINE PAR
      IMPLICIT REAL(A-H,O-Z)
 
      INCLUDE 'inpupara.for'
 
      COMMON/PARAM/NH,NA,KA,METH,IPRINT,IPUNCH,L1,L2,L3,L4,L5,L6,L7,
     .             L8,L9,PRT
      LOGICAL L1,L2,L3,L4,L5,L6,L7,L8,L9,PRT(24)
C
C The number of hydrogen atoms NH will always be 0, because they aren't
C handled separately in the ICON-routines NEWDIA and REPUL.
C
      NH=0
   10 WRITE(6,20) MXATOM
   20 FORMAT(/,' Number of atoms (max. ',I4,'): ',$)
      READ(5,*,ERR=10) NA
      IF (NA .GT. MXATOM) GOTO 10
   30 WRITE(6,40)
   40 FORMAT($,' Molecular charge .........: ')
      READ(5,50,ERR=30) KA
   50 FORMAT(I3)
      RETURN
      END
